<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Google Analytics GA4 Custom Form
 */

namespace Amasty\GA4CustomForm\Model;

use Amasty\GA4\Model\ConfigProvider as ParentConfigProvider;
use Magento\Store\Model\ScopeInterface;

class ConfigProvider extends ParentConfigProvider
{
    public const ENABLE_FORM = 'general/enable_form';

    public function isEnableForm(?int $storeId = null, string $scope = ScopeInterface::SCOPE_STORE): bool
    {
        return $this->isSetFlag(self::ENABLE_FORM, $storeId, $scope);
    }
}
