<?php

declare(strict_types=1);

/**
 * @author Amasty Team
 * @copyright Copyright (c) Amasty (https://www.amasty.com)
 * @package Google Analytics GA4 Custom Form
 */

namespace Amasty\GA4CustomForm\Model\Event\Logger;

use Amasty\GA4Api\Api\Event\EventLoggerInterface;
use Amasty\GA4Api\Model\DataLayerCollector;
use Magento\Framework\View\Element\Template;
use Magento\Framework\View\LayoutInterface;

class CustomForm implements EventLoggerInterface
{
    public const BLOCK_NAME = 'amasty.ga4.form-track';

    /**
     * @var LayoutInterface
     */
    private LayoutInterface $layout;

    public function __construct(
        LayoutInterface $layout
    ) {
        $this->layout = $layout;
    }

    public function execute(): void
    {
        if ($this->layout->getBlock(self::BLOCK_NAME)) {
            return;
        }

        $formTrackBlock = $this->layout->createBlock(
            Template::class,
            self::BLOCK_NAME
        );
        $formTrackBlock->setTemplate('Amasty_GA4CustomForm::form-track.phtml');
        $this->layout->setChild('before.body.end', self::BLOCK_NAME, self::BLOCK_NAME);
    }
}
