define([
    'jquery'
], function ($) {
    'use strict';

    $.widget('amGa4.amFormTrack', {
        options: {
            customForm: {
                events: {
                    open: 'amasty_customform_open',
                    close: 'amasty_customform_close',
                    ajaxSubmit: 'amasty_customform_ajax_submit'
                },
                idDataAttribute: {
                    openButton: 'amformShow',
                    formNode: 'amformId'
                },
                openButtonSelector: '.amform-show-popup.amcform-button',
                closeEventName: 'amcform-popup-close',
                ajaxSubmitEventName: 'amcform-submit-success'
            }
        },

        /**
         * @private
         * @returns {void}
         */
        _create: function () {
            this.bindCustomFormOpenEvent();
            this.bindCustomFormCloseEvent();
            this.bindCustomFormAjaxSubmitEvent();
        },

        /**
         * @returns {void}
         */
        bindCustomFormOpenEvent: function () {
            $(this.options.customForm.openButtonSelector).on('click', (event) => {
                window.dataLayer?.push({
                    event: this.options.customForm.events.open,
                    form_id: $(event.target).data(this.options.customForm.idDataAttribute.openButton)
                });
            });
        },

        /**
         * @returns {void}
         */
        bindCustomFormCloseEvent: function () {
            $(document).on(this.options.customForm.closeEventName, (event, form) => {
                window.dataLayer?.push({
                    event: this.options.customForm.events.close,
                    form_id: $(form).data(this.options.customForm.idDataAttribute.formNode)
                });
            });
        },

        /**
         * @returns {void}
         */
        bindCustomFormAjaxSubmitEvent: function () {
            $(document).on(this.options.customForm.ajaxSubmitEventName, (event, form) => {
                window.dataLayer?.push({
                    event: this.options.customForm.events.ajaxSubmit,
                    form_id: $(form).data(this.options.customForm.idDataAttribute.formNode)
                });
            });
        }
    });

    return $.amGa4.amFormTrack;
});
